package cn.yw.machinemanage.action;

import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import cn.base.aspect.OperateType;
import cn.base.bean.BaseAction;
import cn.base.util.CommUtils;
import cn.base.util.Constants;
import cn.base.util.DateUtil;
import cn.base.util.LogConstants;
import cn.base.util.RHUtil;
import cn.base.util.StringUtil;
import cn.base.util.Struts2Utils;
import cn.bsystem.ptuserrole.model.PtyhBean;
import cn.yw.machinemanage.service.YwmachineinfoService;

@SuppressWarnings({"all"})
@Component("ywmachineinfoAction")
public class YwmachineinfoAction extends BaseAction{
	private static final long serialVersionUID = 1L;
	private static Logger iLog = Logger.getLogger(YwmachineinfoAction.class);
	
	@Autowired
	private YwmachineinfoService service;
	
	/**
	 * 分页
	 */
	
	@OperateType(value = LogConstants.LOG_QUERY ,info ="listYwmachineinfoByPage")
	public void listYwmachineinfoByPage(){
		Map map = Struts2Utils.getRequestParameterMap();
		try {
			int page = Integer.parseInt(Struts2Utils.getParameter("page"));
			int rows = Integer.parseInt(Struts2Utils.getParameter("rows"));
			int start = ( (page == 0 ?  1 : page ) - 1) * rows ;
			map.put("start",start );
			map.put("limit",rows );
			Struts2Utils.renderJson(this.service.listYwmachineinfoByPage(map));
		} catch (Exception e) {
			e.printStackTrace();
			iLog.error("YwmachineinfoAction-listYwmachineinfoByPage-error:" +e);
			Struts2Utils.renderJson(null);
		}
	}
	
	
	/**
	 * 查询总数
	 */
	
	@OperateType(value = LogConstants.LOG_QUERY ,info ="count_Ywmachineinfo")
	public void count_Ywmachineinfo(){
		Map map = Struts2Utils.getRequestParameterMap();
		try {
			Struts2Utils.renderJson(this.service.count_Ywmachineinfo(map));
		} catch (Exception e) {
			e.printStackTrace();
			iLog.error("YwmachineinfoAction-count_Ywmachineinfo-error:" +e);
			Struts2Utils.renderJson(null);
		}
	}
	
	
	/**
	 * 查询 Ywmachineinfo
	 */
	
	@OperateType(value = LogConstants.LOG_GET ,info ="query_Ywmachineinfo")
	public void query_Ywmachineinfo(){
		Map map = Struts2Utils.getRequestParameterMap();
		try {
			Struts2Utils.renderJson(this.service.query_Ywmachineinfo(map));
		} catch (Exception e) {
			e.printStackTrace();
			iLog.error("YwmachineinfoAction-query_Ywmachineinfo-error:" +e);
			Struts2Utils.renderJson(null);
		}
	}
	
	
	/**
	 * 查询 一条Ywmachineinfo
	 */
	
	@OperateType(value = LogConstants.LOG_GET ,info ="get_Ywmachineinfo")
	public void get_Ywmachineinfo(){
		Map map = Struts2Utils.getRequestParameterMap();
		try {
			Struts2Utils.renderJson(this.service.get_Ywmachineinfo(map));
		} catch (Exception e) {
			e.printStackTrace();
			iLog.error("YwmachineinfoActionquery_Ywmachineinfo-error:" +e);
			Struts2Utils.renderJson(null);
		}
	}
	
	
	/**
	 * 删除
	 */
	
	@OperateType(value = LogConstants.LOG_DELETE ,info ="deleteYwmachineinfo")
	public void delete_Ywmachineinfo(){
		Map map = Struts2Utils.getRequestParameterMap();
		try {
			if(!CommUtils.isEmpty(map)){
				int result = service.delete_Ywmachineinfo(map);
				Struts2Utils.renderJson(Constants.SUCCESS);
			}else{
				 throw new Exception("请正确的选择删除记录!!!");
			}
		} catch (Exception e) {
			e.printStackTrace();
			iLog.error("YwmachineinfoAction-delete_Ywmachineinfo-error:" +e);
			Struts2Utils.renderJson(null);
		}
	}
	

	/**
	 * 插入
	 */
	
	@OperateType(value = LogConstants.LOG_ADD ,info ="insert_Ywmachineinfo")
	public void insert_Ywmachineinfo(){
		Map map = Struts2Utils.getRequestParameterMap();
		try {
			if(StringUtil.checkEmpty(map.get("machineid"))){
				map.put("machineid",StringUtil.getUUID());
			}
			String username = ((PtyhBean)Struts2Utils.getSession().getAttribute("userInfo")).getYhbh();
			String time = DateUtil.getDateTimeStr(new Date());
			map.put("createaccount", username);
			map.put("createtime", time);
			map.put("modifyaccount", username);
			map.put("modifytime", time);
			service.insert_Ywmachineinfo(map);
			Struts2Utils.renderJson(Constants.SUCCESS);		
		} catch (Exception e) {
			e.printStackTrace();
			iLog.error("YwmachineinfoAction-insert_Ywmachineinfo()-error:" +e);
			Struts2Utils.renderJson(null);
		}
	}
	
	
	/**
	 * 修改
	 */
	
	@OperateType(value = LogConstants.LOG_UPDATE ,info ="update_Ywmachineinfo")
	public void update_Ywmachineinfo(){
		Map map = Struts2Utils.getRequestParameterMap();
		try {
			String username = ((PtyhBean)Struts2Utils.getSession().getAttribute("userInfo")).getYhbh();
			String time = DateUtil.getDateTimeStr(new Date());
			map.put("modifyaccount", username);
			map.put("modifytime", time);
			
			if(!StringUtil.checkEmpty(map.get("checkparam"))){
				Map sMap = new HashMap();
				sMap.put("tableparam", map.get("checkparam"));
				List ls = service.query_Ywmachineinfo(sMap);
				if(!StringUtil.checkEmpty(ls)||ls.size()>0){
					Struts2Utils.renderJson(Constants.SAME);
				}else{
					int result = service.update_Ywmachineinfo(map);
					Struts2Utils.renderJson(Constants.SUCCESS);
				}
			}else{
				int result = service.update_Ywmachineinfo(map);
				Struts2Utils.renderJson(Constants.SUCCESS);
			}
		} catch (Exception e) {
			e.printStackTrace();
			iLog.error("YwmachineinfoAction-update_Ywmachineinfo-error: " +e);
			Struts2Utils.renderJson(null);
		}
	}
	
	// 更新
	@OperateType(value = LogConstants.LOG_UPDATE ,info ="edit_Ywmachineinfo")
	public void edit_Ywmachineinfo(){
		Map map = Struts2Utils.getRequestParameterMap();
		try {
			String username = ((PtyhBean)Struts2Utils.getSession().getAttribute("userInfo")).getYhbh();
			String time = DateUtil.getDateTimeStr(new Date());
			map.put("modifyaccount", username);
			map.put("modifytime", time);
			String ids = (String) map.get("ids");
			if(RHUtil.isNotEmpty(ids)) {
				String[] keys = ids.split(",");
				map.put("keys", keys);
			}				
			int result = service.edit_Ywmachineinfo(map);
			Struts2Utils.renderJson(Constants.SUCCESS);			
		} catch (Exception e) {
			e.printStackTrace();
			iLog.error("YwmachineinfoAction-edit_Ywmachineinfo-error: " +e);
			Struts2Utils.renderJson(null);
		}
	}
	
	/**
	 * 批量删除
	 */
	
	@OperateType(value = LogConstants.LOG_DELETE ,info ="batch_delete_Ywmachineinfo")
	public void batch_delete_Ywmachineinfo(){
		Map map = Struts2Utils.getRequestParameterMap();
		try {
			String keys = map.get("keyword").toString();
			if(RHUtil.isNotEmpty(keys)) {
				String[] ids = keys.split(",");
				map.put("ids", ids);
			}
			int result = service.batch_delete_Ywmachineinfo(map);
			Struts2Utils.renderJson(Constants.SUCCESS);
		} catch (Exception e) {
			e.printStackTrace();
			iLog.error("YwmachineinfoAction-batch_delete_Ywmachineinfo-error:" +e);
			Struts2Utils.renderJson(null);
		}
	}
	
	
	/**
	 * 导出Excel
	 */
	/*
	//@OperateType(value = LogConstants.LOG_EXPORT ,info ="exp_Ywmachineinfo")
	public void exp_Ywmachineinfo(){
		try {
			Map map = Struts2Utils.getRequestParameterMap();
			map.put("start",0 );
			map.put("limit",5000);
			List<Map> sList = service.query_Ywmachineinfo(map);		
			List<HashMap> expList = new ArrayList<HashMap>();
			for(Map m : sList){
				Map exportMap = new HashMap();
				exportMap.put("yhzh", m.get("yhzh"));
				expList.add((HashMap) exportMap);
			}
			int excelNum = 2;
			ExcelCol[] cells = new ExcelCol[excelNum];
			String[] zdbm = {"yhzh", "yhmc",};
			String[] zdmc = {"用户账号", "用户名称"};
			for(int i=0;i<excelNum;i++){
				cells[i] = new ExcelCol();
				cells[i].setColKey(zdbm[i]);
				cells[i].setColName(zdmc[i]);
			}		
			SimpleDateFormat formart = new SimpleDateFormat("yyyy-MM-dd");   
        	String dateTime=formart.format(new Date()); 
			Map params = new HashMap();
			params.put("fileName", "运维服务器信息表-"+dateTime);
			params.put("sheetName", "运维服务器信息表");
			params.put("header", "运维服务器信息表");	
			new ExportEngine().exportCommData(params, cells, (ArrayList)map.get("rows"), Struts2Utils.getResponse());
		} catch (Exception e) {
			e.printStackTrace();
			iLog.error("YwmachineinfoAction-exoprtExcel-error:" +e);
			
		}
	}
	*/
	
	/**
	 * 导入Excel
	 */
	/*
	//@OperateType(value = LogConstants.LOG_IMPORT ,info ="imp_Ywmachineinfo")
	public String imp_Ywmachineinfo(String excelFile,Object user) {
		String rs = "导入格式有误!";
		int rowNum = 0;
		int dataCount = 0;
		int successNum = 0;
		int repeatNum = 0;
		int failNum = 0;
		try {
		
			ExcelReader readExcel = new ExcelReader();
			readExcel.openFile(excelFile);
			readExcel.setSheetNum(0);
			int count = readExcel.getRowCount();
			iLog.info("总行数count--->" + count);
			rs = " 导入数据成功！总共"+ dataCount +"条数据,重复"+repeatNum+"条数据！失败"+failNum+"条数据!";
			File file = new File(excelFile);
			if(file.exists()){
				file.delete();
			}
		} catch (Exception e) {
			if (rowNum > 3) {
				rs = "资源部分导入(更新)失败！Excel第" + rowNum + "行起未导入(更新)成功！";
			} else {
				rs = "资源导入(更新)失败！";
			}
			iLog.error("YwmachineinfoAction-imp_Ywmachineinfo-error:" +e);
			e.printStackTrace();
		}		
		return rs;
	}
	*/
	
	// 首页    运维数据看板 下数字统计
	public void count_HomepageDeviceCount(){
		Map map = Struts2Utils.getRequestParameterMap();
		try {
			Struts2Utils.renderJson(this.service.count_HomepageDeviceCount(map));
		} catch (Exception e) {
			e.printStackTrace();
			iLog.error("YwmachineinfoAction - count_HomepageDeviceCount - error:" +e);
			Struts2Utils.renderJson(null);
		}
	}
}
